VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFileString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
' Diese Klasse stellt fr Dateinamen Umwandlungsfunktionen zur Verfgung
' Langer Dateiname = Verzeichnis + Dateiname + Erweiterung ("c:\test.tmp")
' Dateiname        = Dateiname + Erweiterung               ("test.tmp")
' Kurzer Dateiname = Dateiname                             ("test")
' Verzeichnis      = Verzeichnis ohne \                    ("c:\temp")
' UNC              = \\SERVER\LW

Option Explicit

Option Compare Text                                 'damit Gro und Kleinschreibung nicht beachtet wird


Private Const MAX_PATH = 260                ' keine Ahnung warum !
Private Const INVALID_HANDLE_VALUE = -1

Private Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
   dwFileAttributes As Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As Long
   nFileSizeLow As Long
   dwReserved0 As Long
   dwReserved1 As Long
   cFileName As String * MAX_PATH
   cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Private fso As FileSystemObject                         ' Microsoft Scripting - Runtime importieren !

Public Function ermittleTempVerzeichnis() As String
    ermittleTempVerzeichnis = fso.GetSpecialFolder(2)   'gendert Rhrl 04.06.2002 (TemporaryFolder)
End Function

'---------------------------------------------------------------------------------------
' Procedure : ersetzeSonderzeichen
' DateTime  : 02.12.2003 12:02
' Author    : Niesner
' Purpose   : ersetzt im Text sText alle Zeichen die nicht in Dateinamen vorkommen sollten
'           : durch einen  Unterstrich
' Info      :
'---------------------------------------------------------------------------------------
Public Function ersetzeSonderzeichen(ByVal sText As String) As String
    Const c_sSonderzeichen As String = " ,;:-#'+*~`?=)(/&%$""!}][{@<>|^"
    Const c_sErsatz = "_"
    Dim sResult As String
    Dim lZeichenZeiger As Long
    Dim sLaufwerk As String
    If Mid(sText, 2, 1) = ":" Then
        sLaufwerk = Mid(sText, 1, 2)
        sResult = Mid(sText, 3)
    Else
        sLaufwerk = ""
        sResult = sText
    End If
    For lZeichenZeiger = 1 To Len(c_sSonderzeichen)
        sResult = Replace(sResult, Mid(c_sSonderzeichen, lZeichenZeiger, 1), c_sErsatz)
    Next lZeichenZeiger
    ersetzeSonderzeichen = sLaufwerk + sResult
End Function

' Ermittelt die Dateigrsse der bergebenen Datei
' RETURN: Dateigrsse, -1 wenn Datei nicht existiert
Public Function ermittleDateigroesse(ByVal sBeliebigerDateiName As String) As Long
    Dim fiDatei As File
    
    sBeliebigerDateiName = Replace(sBeliebigerDateiName, "/", "\") ' ROE: gendert: UNIX-Namen bersetzen
    
    On Error Resume Next
        Set fiDatei = fso.GetFile(sBeliebigerDateiName)
            If (Err.Number <> 0) Then
                Err.Clear
                ermittleDateigroesse = -1
            Else
                ermittleDateigroesse = fiDatei.Size
            End If
        Set fiDatei = Nothing
    On Error GoTo 0
    
'    Dim lHandle As Long
'    Dim lErgebnis As Long
'    Dim wfd As WIN32_FIND_DATA                          ' der FileControlBlock
'
'    lHandle = FindFirstFile(sBeliebigerDateiName, wfd)
'    If (lHandle <> INVALID_HANDLE_VALUE) Then           ' Datei gefunden =>
'        FindClose lHandle                               ' Datei wieder schlieen !
'        lErgebnis = wfd.nFileSizeLow
'    Else                                                ' Datei nicht gefunden !
'        lErgebnis = -1
'    End If
'
'    ermittleDateigroesse = lErgebnis
End Function

' FileSystemObject anlegen
Private Sub Class_Initialize()
   Set fso = CreateObject("Scripting.FileSystemObject")
   
End Sub
' FileSystemObject freigeben
Private Sub Class_Terminate()
    Set fso = Nothing
End Sub

Public Function ermittleAenderungsDatum(ByVal sLangerdateiname As String) As Date
    Dim objDatei As File                                    ' Microsoft Scripting - Runtime importieren !
    Set objDatei = fso.GetFile(sLangerdateiname)
    ermittleAenderungsDatum = objDatei.DateLastModified
    Set objDatei = Nothing
End Function

' Diese Funktion ermittelt aus einem langen Dateinamen das Verzeichnis          ' ROE: erweitert auf UNIX-Pfade !
Public Function ermittleVerzeichnis(ByVal sLangerdateiname As String) As String
    Dim lPosition As Long
    Dim sErgebnis As String
    
    ermittleVerzeichnis = ""                                                    ' Standardwert
    
    For lPosition = Len(sLangerdateiname) To 1 Step -1                          ' von hinten nach vorne
        If (Mid$(sLangerdateiname, lPosition, 1) = "\" Or _
            Mid$(sLangerdateiname, lPosition, 1) = "/") Then                    ' nach \ oder / suchen
            sErgebnis = Left$(sLangerdateiname, lPosition - 1)
            Exit For                                                            ' gefunden !!
        End If
    Next lPosition
    
    'If (Left$(sErgebnis, 1) = "\" Or Left$(sErgebnis, 1) = "/") Then
        ' weglassen ?
    'End If
    
    ermittleVerzeichnis = sErgebnis
End Function

' Diese Funktion ermittelt aus einem langen Dateinamen den Dateinamen           ' ROE: erweitert auf UNIX-Pfade !
Public Function ermittleDateiname(ByVal sLangerdateiname As String) As String
    Dim lPosition As Long
    
    ermittleDateiname = sLangerdateiname                                        ' Standardwert
    
    For lPosition = Len(sLangerdateiname) To 1 Step -1                          ' von hinten nach vorne
        If (Mid$(sLangerdateiname, lPosition, 1) = "\" Or _
            Mid$(sLangerdateiname, lPosition, 1) = "/") Then                    ' nach \ oder / suchen
            ermittleDateiname = Right$(sLangerdateiname, Len(sLangerdateiname) - lPosition)
            Exit For                                                            ' gefunden !!
        End If
    Next lPosition
    
End Function
' diese Funktion ermittel den langen Dateinamen ohne die Erweiterung
Public Function ermittleLangerDateiNameOhneErweiterung(ByVal sLangerdateiname As String) As String
    Dim sVerzeichnis As String
    Dim sDateiName As String
    
    sVerzeichnis = Me.ermittleVerzeichnis(sLangerdateiname)
    sDateiName = Me.ermittleKurzenDateiName(sLangerdateiname)
    
    ermittleLangerDateiNameOhneErweiterung = sVerzeichnis & "\" & sDateiName
End Function
' Diese Funktion ermittelt aus einem beliebigen Dateinamen die Erweiterung
Public Function ermittleErweiterung(ByVal sBeliebigerDateiName As String) As String
    Dim lPosition As Long
    Dim sDateiName As String
    
    sDateiName = ermittleDateiname(sBeliebigerDateiName)                        ' erst mal den DateiNamen
                                                                                ' ohne das Verzeichnis ermitteln
    ermittleErweiterung = ""                                                    ' Standardwert
    
    For lPosition = Len(sDateiName) To 1 Step -1                                ' von hinten nach vorne
        If (Mid$(sDateiName, lPosition, 1) = ".") Then                          ' nach . suchen
            ermittleErweiterung = Right$(sDateiName, Len(sDateiName) - lPosition)
            Exit For                                                            ' gefunden !!
        End If
    Next lPosition
                                                                                
End Function

' Ermittelt zu einem UNC-Pfad das Laufwerk + Dateinamen
Public Function ermittleLaufwerkUndLangenDateiNamen(ByVal sBeliebigerDateiName As String) As String
    Dim lLaufwerk As Long
    Dim sLaufwerkUNC As String
    Dim sErgebnis As String
    
    sErgebnis = sBeliebigerDateiName
    
    For lLaufwerk = Asc("z") To Asc("a") Step -1
        sLaufwerkUNC = ermittleUNC(Chr$(lLaufwerk))
        If (LCase$(sLaufwerkUNC) = LCase$(fso.GetDriveName(sBeliebigerDateiName))) Then
            sErgebnis = Chr$(lLaufwerk) & ":" & Mid$(sBeliebigerDateiName, Len(sLaufwerkUNC) + 1, Len(sBeliebigerDateiName) - Len(sLaufwerkUNC))
            Exit For
        End If
    Next lLaufwerk
    
    ermittleLaufwerkUndLangenDateiNamen = sErgebnis
End Function

' Diese Funktion ermittelt den Kurzen Dateinamen aus einem beliebigenNamen
Public Function ermittleKurzenDateiName(ByVal sBeliebigerDateiName As String) As String
    'Dim lPosition As Long
    Dim sDateiName As String
    Dim lPunktPos As Long
    
    sDateiName = ermittleDateiname(sBeliebigerDateiName)                        ' erst mal den DateiNamen
                                                                                ' ohne das Verzeichnis ermitteln
    
    lPunktPos = InStrRev(sDateiName, ".", -1, vbTextCompare)
    If lPunktPos = 0 Then
        ermittleKurzenDateiName = sDateiName                                        ' Standardwert
    Else
    '    ermittleKurzenDateiName = Left$(sDateiName, InStr(1, sDateiName, ".", vbTextCompare) - 1)
        ermittleKurzenDateiName = Left$(sDateiName, InStrRev(sDateiName, ".", -1, vbTextCompare) - 1)
    End If
End Function

' Diese Funktion liefert true zurck, wenn die Datei existiert
Public Function existiertDatei(ByVal sBeliebigerDateiName As String) As Boolean
    existiertDatei = fso.FileExists(sBeliebigerDateiName)
        
End Function
' Diese Funktion ermittelt, ob ein Verzeichnis existiert
Public Function existiertVerzeichnis(ByVal sBeliebigerVerzeichnisName As String) As Boolean
    
    existiertVerzeichnis = fso.FolderExists(sBeliebigerVerzeichnisName)
End Function

' Diese Funktion erstellt ein neues Verzeichnis. Sollten in der angegebenen Hierarchie
' die Verzeichnisse nicht existieren werden diese EINZELN rekursiv angelegt
Public Function erstelleVerzeichnis(ByVal sBeliebigerVerzeichnisName As String)
    Dim lPosition As Long
    Dim sOberesVerzeichnis As String
                                                                ' obere Verzeichnisebene ermitteln
    For lPosition = Len(sBeliebigerVerzeichnisName) To 1 Step -1
        If (Mid$(sBeliebigerVerzeichnisName, lPosition, 1) = "\") Then  ' "\" gefunden
            sOberesVerzeichnis = Left$(sBeliebigerVerzeichnisName, lPosition - 1)
            Exit For
        End If
    Next lPosition
    
    If (existiertVerzeichnis(sOberesVerzeichnis) = False) Then  ' falls das obere Verzeichnis
        erstelleVerzeichnis sOberesVerzeichnis                  ' nicht existiert, rekursiver Aufruf
    End If
    
    On Error Resume Next
    fso.CreateFolder sBeliebigerVerzeichnisName                 '    unteres gefahrlos erstellen
    If (Err.Number <> 0 And Err.Number <> 58) Then              ' Fehlerlos und "Verzeichnis existiert"
        Err.Clear
    End If
    On Error GoTo 0
End Function
' Diese Funktion liefert den vollstndigen Dateinamen zurck und
' wandelt dabei den Laufwerksbuchstaben in den Servernamen um !
Public Function ermittleUNCundLangerDateiName(ByVal sLangerdateiname As String) As String
    Dim sLaufwerk As String
    Dim sUNCundLangerDateiName As String
    
    sUNCundLangerDateiName = sLangerdateiname
    
    sLaufwerk = LCase$(Left$(sLangerdateiname, 1))      ' Laufwerksbuchstabe
    If (sLaufwerk >= "a" And sLaufwerk <= "z") Then
        If (Mid$(sLangerdateiname, 2, 1) = ":") Then    ' ":" dabei ?
            sUNCundLangerDateiName = _
                ermittleUNC(sLaufwerk) & Right$(sLangerdateiname, Len(sLangerdateiname) - 2)
        End If
    End If
    
    ermittleUNCundLangerDateiName = sUNCundLangerDateiName
End Function
' Liefert zu einem Laufwerksbuchstaben den Servernamen zurck
Public Function ermittleUNC(ByVal sLaufwerksBuchstabe As String) As String
    Dim Laufwerk As Drive
    Dim sUNC As String                                  ' Das Ergebnis
    
    sLaufwerksBuchstabe = Left$(sLaufwerksBuchstabe, 1) ' Nur das Laufwerk !
    
    sUNC = sLaufwerksBuchstabe + ":"                    ' Standardwert
        For Each Laufwerk In fso.Drives                 ' Die einzelnen LW durchsuchen
            
            If (LCase$(Laufwerk.DriveLetter) = LCase(sLaufwerksBuchstabe)) _
                        And (Laufwerk.DriveType = Remote) Then           'Abfrage auf Remote am 25.10.02 ergnzt Niesner
                On Error Resume Next
                sUNC = Laufwerk.ShareName               ' Hier tritt ein Fehler auf, wenn die Netzlaufwerke
                                                        ' getrennt wurden.
                Exit For
            End If
        Next Laufwerk
        Set Laufwerk = Nothing
    ermittleUNC = sUNC
End Function

' Diese Funktion entfernt die fhrenden und abschlieenden Anfhrungszeichen
Public Function entferneAnfuehrungsZeichen(ByVal sBeliebigerDateiName As String)
    
    If (Left$(sBeliebigerDateiName, 1) = """") Then                 ' fhrende und endende " entfernen
        sBeliebigerDateiName = Mid$(sBeliebigerDateiName, 2, Len(sBeliebigerDateiName) - 2)
    End If
    
    entferneAnfuehrungsZeichen = sBeliebigerDateiName
End Function

'konvertiert einen Pfad mit Laufwerksbuchstaben in einen UNC-Pfad
Public Function convertNachUNC(ByVal sBeliebigerDateiName) As String
    Dim sLaufwerk As String
    Dim sDateiNameOhneLaufwerk As String
    sLaufwerk = Left(sBeliebigerDateiName, 1)
    sDateiNameOhneLaufwerk = Right(sBeliebigerDateiName, Len(sBeliebigerDateiName) - 2)
    If Left(sBeliebigerDateiName, 2) = "\\" Then
        convertNachUNC = sBeliebigerDateiName
    Else
        If UCase(sLaufwerk) Like "[A-Z]" Then
            convertNachUNC = ermittleUNC(sLaufwerk) + sDateiNameOhneLaufwerk
        Else
            convertNachUNC = ""
        End If
    End If
    
End Function

'liefer True wenn der angemeldete Benutzer ndernrechte auf die Datei hat.
'Diese Funktion ist nicht ganz sauber, da die entscheidung durch einen Umbenenen Test gemacht wird
Public Function schreibRecht(ByVal sBeliebigerDateiName As String) As Boolean
    Dim bErgebnis As Boolean
    Err.Clear
    On Error Resume Next
        fso.MoveFile sBeliebigerDateiName, sBeliebigerDateiName + "_test"
        fso.MoveFile sBeliebigerDateiName + "_test", sBeliebigerDateiName
        If (Err.Number <> 0) Then
            Err.Clear
            bErgebnis = False
        Else
            bErgebnis = True
        End If
    On Error GoTo 0
    schreibRecht = bErgebnis
End Function

' ***** Manipulationsfunktionen
' benennt die Datei um
Public Function benenneUm(ByVal sAlterDateiname As String, ByVal sNeuerDateiName As String) As Long
    On Error Resume Next
    
    Kill sNeuerDateiName                            ' falls existiert, lschen
        Err.Clear                                   ' Fehler lschen
    fso.MoveFile sAlterDateiname, sNeuerDateiName
    benenneUm = Err.Number
    
End Function

' lscht die Angegebene Datei und liefert 0, wenn kein Fehler auftritt, zurck
Public Function loescheDatei(ByRef sLangerdateiname As String) As Long
    On Error Resume Next
    Err.Clear
    
    Call fso.DeleteFile(sLangerdateiname, True)
    
    loescheDatei = Err.Number
    Err.Clear
    
End Function

' lscht das angegebene Verzeichnis und liefert 0, wenn kein Fehler auftritt, zurck
Public Function loescheVerzeichnis(ByRef sVerzeichnis As String) As Long
    On Error Resume Next
    
        Call fso.DeleteFolder(sVerzeichnis, True)
        loescheVerzeichnis = Err.Number
        Err.Clear
    On Error GoTo 0
End Function

' kopiert die Datei um
Public Function kopiereDatei(ByVal sAlterDateiname As String, ByVal sNeuerDateiName As String) As Long
    Dim sVerzeichnis As String
                
    kopiereDatei = 0
    
    sVerzeichnis = ermittleVerzeichnis(sNeuerDateiName)
    If Not existiertVerzeichnis(sVerzeichnis) Then
        Call erstelleVerzeichnis(sVerzeichnis)
    End If
    On Error Resume Next
    Err.Clear                                   ' Fehler lschen
    If existiertDatei(sNeuerDateiName) Then
        Call loescheDatei(sNeuerDateiName)
    End If
    If existiertDatei(sAlterDateiname) Then
        fso.CopyFile sAlterDateiname, sNeuerDateiName
        kopiereDatei = Err.Number
    Else
        kopiereDatei = -1
    End If
    
    On Error GoTo 0
End Function


'liefert eine Collection mit allen Unterverzeichnissen des SuchVerzeichnisses
Public Function liefereVerzeichnisListe(ByVal Suchverzeichnis As String, Optional ByVal Filter As Collection) As Collection
    Dim VerzeichnisListe As Collection
    Dim Verzeichnis As Folder
    Dim Verzeichnisse As Folders
    Dim i As Long
    
    Set VerzeichnisListe = New Collection
    Set Verzeichnis = fso.GetFolder(Suchverzeichnis)
    Set Verzeichnisse = Verzeichnis.SubFolders
    
    For Each Verzeichnis In Verzeichnisse
        If Filter Is Nothing Then                       'wenn kein Filter
            Call VerzeichnisListe.Add(Verzeichnis.Name) 'dann einfach eintragen
        Else                                            'sonst mit allen Werten des Filters vergelichen
            For i = 1 To Filter.Count
                If Filter(i) Like Verzeichnis.Name Then 'und wenn Treffer, eintragen
                    Call VerzeichnisListe.Add(Verzeichnis.Name)
                    Exit For                            'und raus aus dem Filtersuchlauf
                End If
            Next i
        End If
    Next
    Set liefereVerzeichnisListe = VerzeichnisListe
End Function

'liefert eine Collection mit allen Dateien des SuchVerzeichnisses
Public Function liefereDateiListe(ByVal Suchverzeichnis As String, Optional ByVal Filter As Collection) As Collection
    Dim DateiListe As Collection
    Dim datei As File
    Dim Dateien As Files
    Dim Verzeichnis As Folder
    Dim i As Long
    
    Set DateiListe = New Collection
    Set Verzeichnis = fso.GetFolder(Suchverzeichnis)
    Set Dateien = Verzeichnis.Files
    
    For Each datei In Dateien
        If Filter Is Nothing Then                       'wenn kein Filter
            Call DateiListe.Add(datei.Name) 'dann einfach eintragen
        Else                                            'sonst mit allen Werten des Filters vergelichen
            For i = 1 To Filter.Count
                If datei.Name Like Filter(i) Then 'und wenn Treffer, eintragen
                    Call DateiListe.Add(datei.Name)
                    Exit For                            'und raus aus dem Filtersuchlauf
                End If
            Next i
        End If
    Next
    Set liefereDateiListe = DateiListe
End Function

Public Function liefereSEDateiListe(ByVal Suchverzeichnis) As Collection
    Dim Filter As Collection
    Set Filter = New Collection
    Filter.Add ("*.par")
    Filter.Add ("*.psm")
    Filter.Add ("*.pwd")
    Filter.Add ("*.asm")
    Filter.Add ("*.dft")
    Set liefereSEDateiListe = liefereDateiListe(Suchverzeichnis, Filter)
    Set Filter = Nothing
End Function
